<template>
  <section id="imagePicker" class="gallery-item">
    <label class="plus-sign-wrapper">
      <input type="file" @change="onFileSelected" />
      <div class="btn-container">
        <div class="img">
          <img src="@/assets/images/add-icon.png" alt="Add image" />
        </div>
        <p class="caption">Add your Picture</p>
      </div>
    </label>
  </section>
</template>

<script>
export default {
  name: "imagePicker",
  data() {
    return {};
  },
  methods: {
    onFileSelected(e) {
      let files = e.target.files || e.dataTransfer.files;
      if (!files.length) return;
      this.createImage(files[0]);
    },
    createImage(file) {
      let reader = new FileReader();

      reader.onload = (e) => {
        this.$store.dispatch("addImage", e.target.result);
      };
      reader.readAsDataURL(file);
    },
  },
};
</script>

<style lang="scss" scoped>
@import "../assets/style/main.scss";

#imagePicker {
  @extend %gallery-element-style;
  width: 235px;
  height: 200px;
  background: #fff;
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;

  label {
    cursor: pointer;
  }

  .plus-sign-wrapper {
    position: relative;
    width: 100%;
    height: 100%;
    .btn-container {
      position: absolute;
      top: 50%;
      left: 50%;
      transform: translate(-50%, -50%);
      display: flex;
      align-items: center;
      flex-direction: column;
      .img {
        margin: 0;
        padding: 0;
        width: 45px;
        height: 45px;
        background-color: $blue;
        border-radius: 50%;
        margin: 20px 0 10px;
        display: flex;
        justify-content: center;
        align-items: center;
      }
    }

    input {
      display: none;
    }

    img {
      width: 20px;
      height: 20px;
    }
  }

  .caption {
    width: 100px;
    font: 600 14px Open Sans;
    color: $light-gray;
    text-align: center;
  }
}
</style>
